---
title: "FreeBSD/pc98 5.2.1-RELEASE Release Notes"
sidenav: download
---

++++


<h3 class="CORPAUTHOR">The FreeBSD Project</h3>

<p class="COPYRIGHT">Copyright &copy; 2000, 2001, 2002, 2003, 2004 The FreeBSD
Documentation Project</p>

<p class="PUBDATE">$FreeBSD: src/release/doc/en_US.ISO8859-1/relnotes/common/new.sgml,v
1.663.2.13 2004/02/06 21:37:54 bmah Exp $<br />
</p>

<div>
<div class="ABSTRACT"><a id="AEN13" name="AEN13"></a>
<p>The release notes for FreeBSD 5.2.1-RELEASE contain a summary of recent changes made
to the FreeBSD base system on the 5-CURRENT development branch. This document lists
applicable security advisories that were issued since the last release, as well as
significant changes to the FreeBSD kernel and userland. Some brief remarks on upgrading
are also presented.</p>
</div>
</div>

<hr />
</div>

<div class="TOC">
<dl>
<dt><b>Table of Contents</b></dt>

<dt>1 <a href="#INTRO">Introduction</a></dt>

<dt>2 <a href="#NEW">What's New</a></dt>

<dd>
<dl>
<dt>2.1 <a href="#SECURITY">Security Advisories</a></dt>

<dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

<dd>
<dl>
<dt>2.2.1 <a href="#PROC">Platform-Specific Hardware Support</a></dt>

<dt>2.2.2 <a href="#BOOT">Boot Loader Changes</a></dt>

<dt>2.2.3 <a href="#NET-IF">Network Interface Support</a></dt>

<dt>2.2.4 <a href="#NET-PROTO">Network Protocols</a></dt>

<dt>2.2.5 <a href="#DISKS">Disks and Storage</a></dt>

<dt>2.2.6 <a href="#FS">File Systems</a></dt>

<dt>2.2.7 <a href="#MM">Multimedia Support</a></dt>
</dl>
</dd>

<dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

<dt>2.4 <a href="#CONTRIB">Contributed Software</a></dt>

<dt>2.5 <a href="#PORTS">Ports/Packages Collection Infrastructure</a></dt>

<dt>2.6 <a href="#RELENG">Release Engineering and Integration</a></dt>

<dt>2.7 <a href="#DOC">Documentation</a></dt>
</dl>
</dd>

<dt>3 <a href="#UPGRADE">Upgrading from previous releases of FreeBSD</a></dt>
</dl>
</div>

<div class="SECT1">
<h2 class="SECT1"><a id="INTRO" name="INTRO">1 Introduction</a></h2>

<p>This document contains the release notes for FreeBSD 5.2.1-RELEASE on the NEC PC-98x1
hardware platform. It describes recently added, changed, or deleted features of FreeBSD.
It also provides some notes on upgrading from previous versions of FreeBSD.</p>

<p>This distribution of FreeBSD 5.2.1-RELEASE is a ``point release'', intended to address
some issues (primarily bug fixes) discovered in FreeBSD 5.2-RELEASE.</p>

<p>Users who are new to the 5-CURRENT series of FreeBSD releases should also read the
``Early Adopters Guide to FreeBSD 5.2.1-RELEASE''. This document can generally be found
in the same location as the release notes (either as a part of a FreeBSD distribution or
on the FreeBSD Web site). It contains important information regarding the advantages and
disadvantages of using FreeBSD 5.2.1-RELEASE, as opposed to releases based on the FreeBSD
4-STABLE development branch.</p>

<p>All users are encouraged to consult the release errata before installing FreeBSD. The
errata document is updated with ``late-breaking'' information discovered late in the
release cycle or after the release. Typically, it contains information on known bugs,
security advisories, and corrections to documentation. An up-to-date copy of the errata
for FreeBSD 5.2.1-RELEASE can be found on the FreeBSD Web site.</p>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="NEW" name="NEW">2 What's New</a></h2>

<p>This section describes many of the user-visible new or changed features in FreeBSD
since 5.1-RELEASE. It includes items that are unique to the 5-CURRENT branch, as well as
some features that may have been recently merged to other branches (after FreeBSD
5.1-RELEASE). The latter items are marked as [MERGED].</p>

<p>Typical release note items document recent security advisories issued after
5.1-RELEASE, new drivers or hardware support, new commands or options, major bug fixes,
or contributed software upgrades. They may also list changes to major ports/packages or
release engineering practices. Clearly the release notes cannot list every single change
made to FreeBSD between releases; this document focuses primarily on security advisories,
user-visible changes, and major architectural improvements.</p>

<p>Release note entries that describe changes specific to this point release are marked
with [5.2.1].</p>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="SECURITY" name="SECURITY">2.1 Security Advisories</a></h3>

<p>A single-byte buffer overflow in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=realpath&amp;sektion=3&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">realpath</span>(3)</span></a> was
fixed. Although the fix was committed prior to FreeBSD 5.1-RELEASE (and thus 5.1-RELEASE
was not affected), it was not noted in the release documentation. See security advisory
<a href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:08.realpath.asc"
target="_top">FreeBSD-SA-03:08</a>. [MERGED]</p>

<p>A bug that could allow the kernel to attempt delivery of invalid signals has been
fixed. The bug could have led to a kernel panic or, under some circumstances,
unauthorized modification of kernel memory. For more information, see security advisory
<a href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:09.signal.asc"
target="_top">FreeBSD-SA-03:09</a>. [MERGED]</p>

<p>A bug in the iBCS2 emulation module, which could result in disclosing the contents of
kernel memory, has been fixed. This module is not enabled in FreeBSD by default. For more
information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:10.ibcs2.asc"
target="_top">FreeBSD-SA-03:10</a>. [MERGED]</p>

<p>A buffer management bug in <b class="APPLICATION">OpenSSH</b>, which could potentially
cause a crash, has been fixed. More information can be found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:12.openssh.asc"
target="_top">FreeBSD-SA-03:12</a>. [MERGED]</p>

<p>A buffer overflow in <b class="APPLICATION">sendmail</b> has been fixed. More
information can be found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:13.sendmail.asc"
target="_top">FreeBSD-SA-03:13</a>. [MERGED]</p>

<p>A bug that could allow the kernel to cause resource starvation which eventually
results in a system panic in the ARP cache code has been fixed. More information can be
found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:14.arp.asc"
target="_top">FreeBSD-SA-03:14</a>. [MERGED]</p>

<p>Several errors in the <b class="APPLICATION">OpenSSH</b> PAM challenge/response
authentication subsystem have been fixed. The impacts of these bugs vary; details can be
found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:15.openssh.asc"
target="_top">FreeBSD-SA-03:15</a>. [MERGED]</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=procfs&amp;sektion=5&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">procfs</span>(5)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=linprocfs&amp;sektion=5&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">linprocfs</span>(5)</span></a>,
which could result in disclosing the contents of kernel memory, has been fixed. More
information can be found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:17.procfs.asc"
target="_top">FreeBSD-SA-03:17</a>. [MERGED]</p>

<p>Four separate security flaws in <b class="APPLICATION">OpenSSL</b>, which could allow
a remote attacker to crash an <b class="APPLICATION">OpenSSL</b>-using application or to
execute arbitrary code with the privileges of the application, have been fixed. More
information can be found in security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:18.openssl.asc"
target="_top">FreeBSD-SA-03:18</a>. [MERGED]</p>

<p>A potential denial of service in <b class="APPLICATION">BIND</b> has been fixed. For
more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:19.bind.asc"
target="_top">FreeBSD-SA-03:19</a>. [MERGED]</p>

<p>[5.2.1] A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mksnap_ffs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mksnap_ffs</span>(8)</span></a>
has been fixed; it caused the creation of a filesystem snapshot to reset the flags on the
filesystem to their default values. The possible consequences depended on local usage,
but could include disabling extended access control lists or enabling the use of setuid
executables stored on an untrusted filesystem. This bug also affected the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dump&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dump</span>(8)</span></a> <var
class="OPTION">-L</var> option, which uses <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mksnap_ffs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mksnap_ffs</span>(8)</span></a>.
Note that <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mksnap_ffs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mksnap_ffs</span>(8)</span></a> is
normally only available to the superuser and members of the <tt
class="GROUPNAME">operator</tt> group. For more information, see security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-04:01.mksnap_ffs.asc"
target="_top">FreeBSD-SA-04:01</a>.</p>

<p>[5.2.1] A bug with the System V Shared Memory interface (specifically the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=shmat&amp;sektion=2&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">shmat</span>(2)</span></a> system
call) has been fixed. This bug can cause a shared memory segment to reference unallocated
kernel memory. In turn, this can permit a local attacker to gain unauthorized access to
parts of kernel memory, possibly resulting in disclosure of sensitive information, bypass
of access control mechanisms, or privilege escalation. More details can be found in
security advisory <a
href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-04:02.shmat.asc"
target="_top">FreeBSD-SA-04:02</a>. [MERGED]</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel Changes</a></h3>

<p>[5.2.1] <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=devfs&amp;sektion=5&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">devfs</span>(5)</span></a> path
rules now work correctly on directories.</p>

<p>The DRM kernel modules have been updated from DRI CVS as of 12 November 2003. Among
other changes, this change includes a newly-ported SiS 300/305/540/630/730 driver and
mostly-complete SMPng locking.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dcons&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dcons</span>(4)</span></a> ``dumb
console'' driver has been added to provide a local and remote console. It can be accessed
over FireWire using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dcons_crom&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dcons_crom</span>(4)</span></a>
driver. A <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dconschat&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dconschat</span>(8)</span></a>
utility provides user access to <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dcons&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dcons</span>(4)</span></a>
devices.</p>

<p>A multi-byte character set conversion method is now supported by the <var
class="LITERAL">LIBICONV</var> kernel option.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hifn&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hifn</span>(4)</span></a> driver
now supports symmetric crypto for the 7955 and 7956 chipsets. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=puc&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">puc</span>(4)</span></a> PCI
Universal Communications driver now supports connecting parallel ports to the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppc&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppc</span>(4)</span></a>
driver.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=safe&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">safe</span>(4)</span></a> driver
has been added to support SafeNet 1141- and 1741-based crypto accelerators. [MERGED]</p>

<div class="WARNING">
<blockquote class="WARNING">
<p><b>Warning:</b> This driver should be considered experimental and should be used with
some caution.</p>
</blockquote>
</div>

<div class="NOTE">
<blockquote class="NOTE">
<p><b>Note:</b> The public key support is not implemented.</p>
</blockquote>
</div>

<br />
<br />
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uart&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uart</span>(4)</span></a> driver
has been added to support various classes of UART (Universal Asynchronous
Receiver/Transmitter) devices. It is an analog of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sio&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sio</span>(4)</span></a> driver
but supports a wider range of devices. This driver is necessary to support serial ports
on certain architectures, such as ia64 and sparc64.</p>

<p>A kernel software watchdog facility has been implemented. For more information, see <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=watchdog&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">watchdog</span>(4)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=watchdogd&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">watchdogd</span>(8)</span></a>.</p>

<p>The swap pager has been revamped. Among user-visible changes are a change in the
layout policy (from fixed-width striping to a round-robin across devices) for better I/O
throughput, the elimination of compile-time limits on the number of swap devices, and a
reduction in memory overheads.</p>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="PROC" name="PROC">2.2.1 Platform-Specific Hardware
Support</a></h4>

<p>Large changes have been made to the i386 machine-dependent code to improve interrupt
routing and handling.</p>

<p>Floating point emulation in the kernel has been removed.</p>

<p>Problems with some Pentium 4 CPUs and some older Pentium Pro and Pentium II CPUs have
been worked around. Typically these manifested themselves as memory corruption or
unexplained crashes.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="BOOT" name="BOOT">2.2.2 Boot Loader Changes</a></h4>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-IF" name="NET-IF">2.2.3 Network Interface Support</a></h4>

<p>The new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ath&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ath</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ath_hal&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ath_hal</span>(4)</span></a>
drivers provide support for 802.11a/b/g devices based on the AR5210, AR5211, and AR5212
chips.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bfe&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bfe</span>(4)</span></a> driver
has been added to support Broadcom BCM4401 based Fast Ethernet adapters.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> now
supports Broadcom 5705 based Gigabit Ethernet NICs. [MERGED]</p>

<p>A bug in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=bge&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">bge</span>(4)</span></a> driver
that prevented it from working correctly at 10 Mbps has been fixed.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a> driver now
has support for tuning the interrupt delays using sysctl tunables without recompiling the
driver.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fatm&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fatm</span>(4)</span></a> driver
has been added. This is a driver for NATM and NgATM that supports Fore/Marconi PCA200 ATM
cards.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=harp&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">harp</span>(4)</span></a> driver
has been added. This is a pseudo physical interface driver for HARP, which attaches to
all NetGraph ATM interfaces in the system and presents a physical interface to the HARP
stack for each of these interfaces.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hatm&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hatm</span>(4)</span></a> driver
has been added to support Fore/Marconi HE155 and HE622 ATM cards.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=patm&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">patm</span>(4)</span></a> driver
has been added to support IDT77252 based ATM interfaces.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=re&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">re</span>(4)</span></a> driver has
been added. It provides support for the RealTek RTL8139C+, RTL8169, RTL8169S and RTL8110S
PCI Fast Ethernet and Gigabit Ethernet controllers.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sk&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sk</span>(4)</span></a> now
supports SK-9521 V2.0 and 3COM 3C940 based Gigabit Ethernet NICs. [MERGED]</p>

<p>[5.2.1] Several bugs related to multicast and promiscuous mode handling in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sk&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sk</span>(4)</span></a> driver
have been fixed.</p>

<p>A new <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=utopia&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">utopia</span>(4)</span></a> driver
supports 25MBit/sec, 155MBit/sec and 622MBit/sec ATM physical layer configuration, status
and statistics reporting for the most commonly used ATM-PHY chips.</p>

<p>The suspend/resume support for the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wi&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wi</span>(4)</span></a> driver now
works correctly when the device is configured down. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wi&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wi</span>(4)</span></a> driver
should once again work correctly with Lucent 802.11b interfaces.</p>

<p>The 802.11 support layer has been rewritten to allow for future growth and new
features.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=xe&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">xe</span>(4)</span></a> driver now
supports CE2, CEM28, and CEM33 cards, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=multicast&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">multicast</span>(4)</span></a>
datagrams. Also several bugs in the driver have been fixed.</p>

<p>A number of network drivers have had their interrupt handlers marked as MPSAFE,
meaning they can run without the Giant lock. Among the drivers so converted are: <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ath&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ath</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=em&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">em</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ep&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ep</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fxp&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fxp</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sn&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sn</span>(4)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=wi&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">wi</span>(4)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sis&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sis</span>(4)</span></a>.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="NET-PROTO" name="NET-PROTO">2.2.4 Network Protocols</a></h4>

<p>The <var class="LITERAL">ip_flow</var> feature in the IPv4 protocol implementation has
been replaced by the <var class="LITERAL">ip_fastforward</var> feature. <var
class="LITERAL">ip_fastforward</var> attempts to speed up simple cases of packet
forwarding, processing a forwarded packet to an outgoing interface without queues or
netisrs. If it cannot handle a particular packet, it passes that packet to the normal
<var class="LITERAL">ip_input</var> routines for processing. This feature can be enabled
by setting the <var class="VARNAME">net.inet.ip.fastforwarding</var> sysctl variable to
<var class="LITERAL">1</var>.</p>

<p>The <var class="LITERAL">IP_ONESBCAST</var> option has been added to enable undirected
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ip&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ip</span>(4)</span></a> broadcasts
to be sent to specific network interfaces.</p>

<p>Enabling the <var class="LITERAL">options IPFILTER</var> feature also requires
enabling <var class="LITERAL">options PFIL_HOOKS</var>.</p>

<p>A bug in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> limit
rule processing that could cause various panics has been fixed. [MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> rules
now support comma-separated address lists (such as <var class="LITERAL">1.2.3.4,
5.6.7.8/30, 9.10.11.12/22</var>), and allow spaces after commas to make lists of
addresses more readable. [MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> rules
now support C++-style comments. Each comment is stored together with its rule and appears
using the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> <var
class="LITERAL">show</var> command. [MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> can now
modify <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(4)</span></a> rules in
set 31, which was read-only and used for the default rules. They can be deleted by <tt
class="COMMAND">ipfw delete set 31</tt> command but are not deleted by the <tt
class="COMMAND">ipfw flush</tt> command. This implements a flexible form of ``persistent
rules''. More details can be found in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a>.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_atmpif&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_atmpif</span>(4)</span></a>
NetGraph node type has been added. It emulates a HARP physical interface, and allows one
to run the HARP ATM stack without real hardware.</p>

<p>Kernel support has been added for Protocol Independent Multicast routing (<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pim&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pim</span>(4)</span></a>).
[MERGED]</p>

<p>The FreeBSD Bluetooth protocol stack has been updated:</p>

<ul>
<li>
<p><b class="APPLICATION">libsdp</b> has been re-implemented under a BSD style license.
This is because the Linux BlueZ code is distributed under the GPL.</p>
</li>

<li>
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hccontrol&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hccontrol</span>(8)</span></a>
utility now supports four new commands: Read/Write_Page_Scan_Mode and
Read/Write_Page_Scan_Period_Mode.</p>
</li>

<li>
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=hcsecd&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">hcsecd</span>(8)</span></a> daemon
now stores link keys on a disk. It is no longer required to pair devices every time.</p>
</li>

<li>
<p>A NetGraph timeout problem in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_hci&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_hci</span>(4)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_l2cap&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_l2cap</span>(4)</span></a>
kernel modules, which could cause access to a data structure that was already freed, has
been fixed.</p>
</li>

<li>
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ng_ubt&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ng_ubt</span>(4)</span></a>
module, which cannot be built on FreeBSD 5.1-RELEASE, has been fixed.</p>
</li>

<li>
<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rfcomm_sppd&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rfcomm_sppd</span>(1)</span></a>
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rfcomm_pppd&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rfcomm_pppd</span>(8)</span></a>
now support to query the RFCOMM channel via SDP from the server. Specifying the RFCOMM
channel manually, this behavior can be disabled and these utilities will not use SDP
query.</p>
</li>

<li>
<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sdpcontrol&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sdpcontrol</span>(8)</span></a>
utility, which is analogous to the sdptool utility in the Linux BlueZ SDP package, has
been added.</p>
</li>
</ul>

<p>A number of fixes and updates to the IPv6 and IPSec code have been imported from the
KAME Project.</p>

<p>[5.2.1] Some bugs in the IPsec implementation from the KAME Project have been fixed.
These bugs were related to freeing memory objects before all references to them were
removed, and could cause erratic behavior or kernel panics after flushing the Security
Policy Database (SPD).</p>

<p>Support for the IPv6 Advanced Sockets API now conforms to RFC 3542 (also known as RFC
2292bis), rather than RFC 2292. Applications using this API have been updated
accordingly.</p>

<p>[5.2.1] The <var class="LITERAL">PFIL_HOOKS</var> option is now enabled by default in
the <tt class="FILENAME">GENERIC</tt> kernel. The most notable effect of this change is
to make <b class="APPLICATION">IPFilter</b> work correctly when loaded as a kernel
module.</p>

<p>Support for the source address selection part of RFC 3484 has been added. The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ip6addrctl&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ip6addrctl</span>(8)</span></a>
utility can be used to configure the address selection policy.</p>

<p>The <var class="LITERAL">tcp_hostcache</var> feature has been added to the TCP
implementation. It caches measured parameters of past TCP sessions to provide better
initial start values for following connections from or to the same source or destination.
Similar information that used to be stored in the routing table has been removed.</p>

<p>The TCP implementation in FreeBSD now includes protection against a certain class of
TCP MSS resource exhaustion attacks, in the form of limits on the size and rate of TCP
segments. The first limit sets the minimum allowed maximum TCP segment size, and is
controlled by the <var class="VARNAME">net.inet.tcp.minmss</var> sysctl variable (the
default value is <var class="LITERAL">216</var> bytes). The second limit is set by the
<var class="VARNAME">net.inet.tcp.minmssoverload</var> variable, and controls the maximum
rate of connections whose average segment size is less than <var
class="VARNAME">net.inet.tcp.minmss</var>. Connections exceeding this packet rate are
reset and dropped. Because this feature was added late in the 5.2-RELEASE release cycle,
connection rate limiting is disabled by default, but can be enabled manually by assigning
a non-zero value to <var class="VARNAME">net.inet.tcp.minmssoverload</var>.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="DISKS" name="DISKS">2.2.5 Disks and Storage</a></h4>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=amr&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">amr</span>(4)</span></a> driver
now has system crashdump support. [MERGED]</p>

<p>A major rework of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
has been committed. One of the more notable changes is that the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver is
now out from under the Giant kernel lock. Note that ATA software RAID systems must now
include <var class="LITERAL">device ataraid</var> in their kernel configuration files, as
it is no longer automatically implied by <var class="LITERAL">device atadisk</var>.</p>

<p>[5.2.1] A number of bugs in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ata</span>(4)</span></a> driver
have been fixed. Most notably, master/slave device detection should work better, and some
problems with timeouts should be resolved.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ccd&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ccd</span>(4)</span></a> can now
operate on raw disks and other <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">geom</span>(4)</span></a>
providers.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=da&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">da</span>(4)</span></a> driver no
longer tries to send 6-byte commands to USB and FireWire devices. The quirks for these
devices (which hopefully are now unnecessary) have been disabled; to restore the old
behavior, add <var class="LITERAL">options DA_OLD_QUIRKS</var> to the kernel
configuration. [MERGED]</p>

<p>Various <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">geom</span>(4)</span></a> modules
can now be loaded as kernel modules, namely: <tt class="FILENAME">geom_apple</tt>, <tt
class="FILENAME">geom_bde</tt>, <tt class="FILENAME">geom_bsd</tt>, <tt
class="FILENAME">geom_gpt</tt>, <tt class="FILENAME">geom_mbr</tt>, <tt
class="FILENAME">geom_pc98</tt>, <tt class="FILENAME">geom_sunlabel</tt>, <tt
class="FILENAME">geom_vol_ffs</tt>.</p>

<p>A <var class="LITERAL">GEOM_FOX</var> module has been added to detect and select
between multiple redundant paths to the same device.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=twe&amp;sektion=4&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">twe</span>(4)</span></a> driver
now supports the 3ware generic API. [MERGED]</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="FS" name="FS">2.2.6 File Systems</a></h4>

<p>Multi-byte character conversion with the cd9660, msdosfs, ntfs, and udf filesystems is
now supported by including the <var class="LITERAL">CD9660_ICONV</var>, <var
class="LITERAL">MSDOSFS_ICONV</var>, <var class="LITERAL">NTFS_ICONV</var>, and <var
class="LITERAL">UDF_ICONV</var> kernel options, respectively.</p>

<p>[5.2.1] A bug in GEOM that could result in I/O hangs in some rare cases has been
fixed.</p>

<p>Some off-by-one errors in the smbfs that prevented it from working correctly with
15-character NetBIOS names have been fixed.</p>

<p>The sizes of some members of the <var class="LITERAL">statfs</var> structure have
changed from 32 bits to 64 bits in order to better support multi-terabyte
filesystems.</p>

<ul>
<li>
<p>Users performing source upgrades across this change must ensure that their kernel and
userland bits are in sync, by following the documented source upgrade procedures.</p>
</li>

<li>
<p>A backward compatibility version of the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=statfs&amp;sektion=2&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">statfs</span>(2)</span></a> system
call exists but only if the <var class="LITERAL">COMPAT_FREEBSD4</var> kernel option is
defined. Including this option in the kernel is strongly encouraged.</p>
</li>

<li>
<p>Programs that use the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=statfs&amp;sektion=2&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">statfs</span>(2)</span></a> will
need to be recompiled. Among the known examples are the <a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/devel/gnomevfs2/pkg-descr"><tt
class="FILENAME">devel/gnomevfs2</tt></a>, <a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/mail/postfix/pkg-descr"><tt
class="FILENAME">mail/postfix</tt></a>, and <a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/security/cfg/pkg-descr"><tt
class="FILENAME">security/cfg</tt></a> ports.</p>
</li>
</ul>

<br />
<br />
<p>Support for NFSv4 has been added with the import of the University of Michigan's Citi
NFSv4 client implementation. More information can be found in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_nfs4&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_nfs4</span>(8)</span></a>
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=idmapd&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">idmapd</span>(8)</span></a> manual
pages.</p>

<p>[5.2.1] A panic in the NFSv4 client has been fixed; this occurred when attempting
operations against an NFSv3/NFSv2-only server.</p>
</div>

<div class="SECT3">
<hr />
<h4 class="SECT3"><a id="MM" name="MM">2.2.7 Multimedia Support</a></h4>
</div>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="USERLAND" name="USERLAND">2.3 Userland Changes</a></h3>

<p>The last bits of the i386-only, a.out compiler toolchain have been removed.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpiconf&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpiconf</span>(8)</span></a> now
supports a <var class="OPTION">-i</var> option to print battery information.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=acpidb&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">acpidb</span>(8)</span></a>, an
ACPI DSDT debugger, has been added.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=arp&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">arp</span>(8)</span></a> now
supports a <var class="OPTION">-i</var> option to limit the scope of the current
operation to the ARP entries on a particular interface. This option applies to the
display operations only. It should be useful on routers with numerous network interfaces.
[MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=asf&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">asf</span>(8)</span></a> utility,
which helps load the symbol files from KLDs into a <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=gdb&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">gdb</span>(1)</span></a> debugging
environment, has been added.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=atmconfig&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">atmconfig</span>(8)</span></a>
program has been added for configuration of the ATM drivers and IP-over-ATM
functionality.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=chroot&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">chroot</span>(8)</span></a> now
allows the optional setting of a user, primary group, or group list to use inside the
chroot environment via the <var class="OPTION">-u</var>, <var class="OPTION">-g</var>,
and <var class="OPTION">-G</var> options respectively. [MERGED]</p>

<p>The <tt class="FILENAME">compat4x.i386</tt> libraries have been updated to correspond
to those available in FreeBSD 4.9-RELEASE.</p>

<p>The dev_mkdb utility is unnecessary due to the mandatory presence of devfs, and has
been removed.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dhclient&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dhclient</span>(8)</span></a> now
polls the state of network interfaces and only sends DHCP requests on interfaces that are
up. The polling interval can be controlled with the <var class="OPTION">-i</var>
option.</p>

<p>The default mode for the <tt class="FILENAME">lost+found</tt> directory of <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck</span>(8)</span></a> is now
<var class="LITERAL">0700</var> instead of <var class="LITERAL">01777</var>. [MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck_ffs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck_ffs</span>(8)</span></a> and
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">newfs</span>(8)</span></a> now
create a <tt class="FILENAME">.snap</tt> directory in the root directory of each
filesystem, with group <tt class="GROUPNAME">operator</tt>. <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=fsck_ffs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">fsck_ffs</span>(8)</span></a>, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mksnap_ffs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mksnap_ffs</span>(8)</span></a>,
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=dump&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">dump</span>(8)</span></a> will
write their filesystem snapshots to this directory. This change avoids locking access to
the root directory of a filesystem during snapshot creation and also helps non-<tt
class="USERNAME">root</tt> users create snapshots.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ffsinfo&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ffsinfo</span>(8)</span></a>
utility has been updated to understand UFS2 filesystems and has been re-enabled.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=iasl&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">iasl</span>(8)</span></a> utility,
a compiler/decompiler for ACPI Source Language (ASL) and ACPI Machine language (AML), has
been added.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ifconfig&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ifconfig</span>(8)</span></a> now
supports a <var class="OPTION">staticarp</var> option for an interface, which disables
the sending of ARP requests for that interface.</p>

<p>A fix in the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=initgroups&amp;sektion=3&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">initgroups</span>(3)</span></a>
library function now causes logins to fail if the login process is unable to successfully
set the process credentials to include <span class="emphasis"><i
class="EMPHASIS">all</i></span> groups defined for a user. The current kernel limit is 16
groups; administrators may wish to check that users do not have more than 16 groups
defined, or they will be unable to log in.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> <var
class="LITERAL">list</var> and <var class="LITERAL">show</var> commands now support
ranges of rule numbers. [MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ipfw</span>(8)</span></a> now
supports a <var class="OPTION">-n</var> flag to test the syntax of commands without
actually changing anything. [MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=kdump&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">kdump</span>(1)</span></a> now
supports a <var class="OPTION">-p</var> option to display only the trace events
corresponding to a specific process, as well as a new <var class="OPTION">-E</var> flag
to display timestamps relative to the start of the dump.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=last&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">last</span>(1)</span></a> now
supports a <var class="OPTION">-n</var> flag to limit the number of lines in its output
report.</p>

<p>The <tt class="FILENAME">libalias</tt> library, <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=natd&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">natd</span>(8)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ppp&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ppp</span>(8)</span></a> now
support Cisco Skinny Station protocol, which is the protocol used by Cisco IP phones to
talk to Cisco Call Managers. Note that currently having the Call Manager behind the NAT
gateway is not supported. [MERGED]</p>

<p>The <tt class="FILENAME">libcipher</tt> DES cryptography library has been removed. All
of its functionality is provided by the <tt class="FILENAME">libcrypto</tt> library, and
all base systems programs that used <tt class="FILENAME">libcipher</tt> have been
converted to use <tt class="FILENAME">libcrypto</tt> instead.</p>

<p>[5.2.1] <tt class="FILENAME">libdisk</tt> now uses the correct PC98 disk partition
value for FreeBSD. This permits the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
disk partition editor to correctly create a single FreeBSD partition covering the entire
disk.</p>

<p>The <tt class="FILENAME">libkiconv</tt> library has been added to support working with
loadable character set conversion tables in the kernel.</p>

<p><tt class="FILENAME">libwrap</tt> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=tcpdchk&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">tcpdchk</span>(8)</span></a> are
now configured to support the extended <b class="APPLICATION">tcp_wrappers</b> syntax by
default.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=locale&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">locale</span>(1)</span></a>
utility has been re-implemented and is now POSIX-compliant. A new <var
class="OPTION">-m</var> option shows all available codesets.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount</span>(8)</span></a> utility
now supports to display the filesystem ID for each file system in addition to the normal
information when a <var class="OPTION">-v</var> flag is specified, and the <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=umount&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">umount</span>(8)</span></a>
utility now accepts the filesystem ID as well as the usual device and path names. This
allows to unambiguously specify which file system is to be unmounted even when two or
more file systems share the same device and mount point names.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_cd9660&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_cd9660</span>(8)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_ntfs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_ntfs</span>(8)</span></a>,
and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_udf&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_udf</span>(8)</span></a>
utilities now support a <var class="OPTION">-C</var> option to specify local character
sets to convert Unicode filenames. It is possible to specify multi-byte character sets
using this option.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_msdosfs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_msdosfs</span>(8)</span></a>
utility now supports a <var class="OPTION">-M</var> option to specify the maximum file
permissions for directories in the file system. [MERGED]</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_msdosfs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_msdosfs</span>(8)</span></a>
utility now supports a <var class="OPTION">-D</var> option to specify MS-DOS codepages
and a <var class="OPTION">-L</var> option to specify local character sets. They are used
to convert character sets of filenames. The <tt
class="FILENAME">/usr/libdata/msdosfs</tt> tables have been retired.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_nwfs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_nwfs</span>(8)</span></a>,
<a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_portalfs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">mount_portalfs</span>(8)</span></a>, and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_smbfs&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">mount_smbfs</span>(8)</span></a>
utilities have been moved from <tt class="FILENAME">/sbin</tt> to <tt
class="FILENAME">/usr/sbin</tt>.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=nologin&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">nologin</span>(8)</span></a>
program has been reimplemented in C (it was formerly a shell script).</p>

<p>[5.2.1] A bugfix has been applied to NSS support, which fixes problems when using
third-party NSS modules (such as <a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/net/nss_ldap/pkg-descr"><tt
class="FILENAME">net/nss_ldap</tt></a>) and groups with large membership lists.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.conf&amp;sektion=5&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rc.conf</span>(5)</span></a>
variable <var class="VARNAME">ntpd_flags</var> for <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ntpd&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ntpd</span>(8)</span></a> now
includes <var class="OPTION">-f /var/db/ntpd.drift</var> by default.</p>

<p>The <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=pam_guest&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">pam_guest</span>(8)</span></a> PAM
module has been added to allow guest logins. It replaces the pam_ftp(8) module.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=ps&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">ps</span>(1)</span></a> and <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=top&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">top</span>(1)</span></a> now
support a <var class="OPTION">-H</var> flag to display all kernel-visible threads in each
process.</p>

<p>A bug that <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rarpd&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rarpd</span>(8)</span></a> does
not recognize removable Ethernet NICs has been fixed.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=repquota&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">repquota</span>(8)</span></a> now
supports a <var class="OPTION">-n</var> flag to display users and groups numerically.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rtld</span>(1)</span></a> now
includes ``libmap'' functionality by default; the <var class="VARNAME">WITH_LIBMAP</var>
compile knob is unnecessary and has been retired. More information can be found in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=libmap.conf&amp;sektion=5&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span
class="REFENTRYTITLE">libmap.conf</span>(5)</span></a>.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=savecore&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">savecore</span>(8)</span></a> now
supports a <var class="OPTION">-C</var> flag that merely indicates the existence or
absence of a coredump file.</p>

<p>The symorder utility has been removed. It is unnecessary now that all kernels use ELF
format and there is no a.out format toolchain.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
now gives the ability to select an alternate MTA during installation. Currently, <b
class="APPLICATION">exim</b> and <b class="APPLICATION">Postfix</b> are supported.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a> no
longer supports system ``security profiles''; this feature has been replaced by
individual tuning knobs to enable and disable <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sshd&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sshd</span>(8)</span></a> and set
the system securelevels.</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=systat&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">systat</span>(1)</span></a> now
includes displays for IPv6 and ICMPv6 traffic. [MERGED]</p>

<p><a
href="http://www.FreeBSD.org/cgi/man.cgi?query=uname&amp;sektion=1&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">uname</span>(1)</span></a> now
supports a <var class="OPTION">-i</var> flag to return the kernel identification. This
name is also available via the <var class="VARNAME">kern.ident</var> sysctl variable.</p>

<p>A number of utilities available in <tt class="FILENAME">/bin</tt> and <tt
class="FILENAME">/sbin</tt> are now available as a statically-linked ``crunched'' binary
that lives in <tt class="FILENAME">/rescue</tt>. This functionality is similar to the <tt
class="FILENAME">/stand</tt> directory installed by <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">sysinstall</span>(8)</span></a>,
but <tt class="FILENAME">/rescue</tt> includes more functionality and is updated as part
of <var class="LITERAL">buildworld</var>/<var class="LITERAL">installworld</var>
operations. More details can be found in <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=rescue&amp;sektion=8&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">rescue</span>(8)</span></a>.</p>

<p>Many executables in <tt class="FILENAME">/bin</tt> and <tt class="FILENAME">/sbin</tt>
are now built using dynamic, rather than static linking. This feature brings support for
loadable PAM and NSS modules to base system utilities located in those directories. It
also reduces the storage requirements for the root filesystem due to the use of shared
libraries. This feature can be disabled in a <var class="LITERAL">buildworld</var> by
defining the Makefile variable <var class="VARNAME">NO_DYNAMICROOT</var>. Note that
statically-linked, crunched executables are available in the <tt
class="FILENAME">/rescue</tt> directory for use during system repair and recovery
operations.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4 Contributed Software</a></h3>

<p>The <b class="APPLICATION">ACPI-CA</b> code has been updated from the 20030228
snapshot to the 20030619 snapshot.</p>

<p><b class="APPLICATION">amd</b> has been updated from 6.0.7 to 6.0.9.</p>

<p><b class="APPLICATION">awk</b> from Bell Labs has been updated from a 14 March 2003
snapshot to a 29 July 2003 snapshot.</p>

<p><b class="APPLICATION">BIND</b> has been updated from 8.3.4 to 8.3.7. [MERGED]</p>

<p>[5.2.1] Security improvements from <b class="APPLICATION">CVS</b> 1.11.10 and 1.11.11
have been backported. Specifically, certain malformed module requests are now rejected,
and when using <tt class="COMMAND">cvs pserver</tt> mode, attempts to authenticate as <tt
class="USERNAME">root</tt> are rejected and recorded via <a
href="http://www.FreeBSD.org/cgi/man.cgi?query=syslog&amp;sektion=3&amp;manpath=FreeBSD+5.2.1-RELEASE">
<span class="CITEREFENTRY"><span class="REFENTRYTITLE">syslog</span>(3)</span></a>.</p>

<p><b class="APPLICATION">GCC</b> has been updated from 3.2.2 to a 3.3.3 pre-release
snapshot from 6 November 2003.</p>

<div class="NOTE">
<blockquote class="NOTE">
<p><b>Note:</b> Previous versions of <b class="APPLICATION">GCC</b> generated incorrect
code when <var class="LITERAL">-march=pentium4</var> optimization was enabled. This
problem is believed to have been fixed with this upgrade, and the earlier workaround for
the case of <var class="LITERAL">CPUTYPE=p4</var> has been removed.</p>
</blockquote>
</div>

<br />
<br />
<p><b class="APPLICATION">GNU Readline</b> has been updated from 4.2 to 4.3.</p>

<p><b class="APPLICATION">GNU Sort</b> has been updated from the version in textutils
2.0.21 to the version in textutils 2.1.</p>

<p><b class="APPLICATION">Heimdal Kerberos</b> has been updated from 0.5.1 to 0.6.</p>

<p>The <b class="APPLICATION">ISC DHCP</b> client has been updated from 3.0.1rc11 to
3.0.1rc12.</p>

<p><b class="APPLICATION">lukemftp</b> has been updated from 1.6beta2 to a 11 November
2003 snapshot from NetBSD.</p>

<p><b class="APPLICATION">OpenPAM</b> has been updated from the ``Dianthus'' release to
the ``Dogwood'' release.</p>

<p><b class="APPLICATION">OpenSSL</b> has been updated from 0.9.7a to 0.9.7c.
[MERGED]</p>

<p><b class="APPLICATION">sendmail</b> has been updated from version 8.12.9 to version
8.12.10. [MERGED]</p>

<p><b class="APPLICATION">texinfo</b> has been updated from 4.5 to 4.6. [MERGED]</p>

<p>The timezone database has been updated from the <tt class="FILENAME">tzdata2003a</tt>
release to the <tt class="FILENAME">tzdata2003d</tt> release. [MERGED]</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="PORTS" name="PORTS">2.5 Ports/Packages Collection
Infrastructure</a></h3>

<p>If <tt class="MAKEVAR">GNU_CONFIGURE</tt> is defined, all instances of <tt
class="FILENAME">config.guess</tt> and <tt class="FILENAME">config.sub</tt> found under
<tt class="FILENAME"><tt class="MAKEVAR">WRKDIR</tt></tt> are replaced with the master
versions from <tt class="FILENAME"><tt class="MAKEVAR">PORTSDIR</tt>/Template</tt>. This
allows old ports (which contain old versions of these scripts) to build on newer
architectures like ia64 and amd64.</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="RELENG" name="RELENG">2.6 Release Engineering and
Integration</a></h3>

<p>The supported release of <b class="APPLICATION">GNOME</b> has been updated from 2.2.1
to 2.4. [MERGED]</p>

<p>The supported release of <b class="APPLICATION">KDE</b> has been updated from 3.1.2 to
3.1.4. [MERGED]</p>

<p>[5.2.1] The <a
href="http://www.FreeBSD.org/cgi/url.cgi?ports/sysutils/kdeadmin3/pkg-descr"><tt
class="FILENAME">sysutils/kdeadmin3</tt></a> port and package have been updated to
version 3.1.4_1. This update fixes a bug in the <b class="APPLICATION">KUser</b>
application that could cause the <tt class="USERNAME">root</tt> user to be deleted from
the password file</p>
</div>

<div class="SECT2">
<hr />
<h3 class="SECT2"><a id="DOC" name="DOC">2.7 Documentation</a></h3>

<p>To reduce duplication of information (and subsequent difficulty in maintaining
consistency), many instances of specific devices supported in the Hardware Notes have
been moved to system manual pages. This project is ongoing as of this release.</p>

<p>A Turkish (tr_TR.ISO8859-9) translation project has been started.</p>
</div>
</div>

<div class="SECT1">
<hr />
<h2 class="SECT1"><a id="UPGRADE" name="UPGRADE">3 Upgrading from previous releases of
FreeBSD</a></h2>

<p>Users with existing FreeBSD systems are <span class="emphasis"><i
class="EMPHASIS">highly</i></span> encouraged to read the ``Early Adopter's Guide to
FreeBSD 5.2.1-RELEASE''. This document generally has the filename <tt
class="FILENAME">EARLY.TXT</tt> on the distribution media, or any other place that the
release notes can be found. It offers some notes on upgrading, but more importantly, also
discusses some of the relative merits of upgrading to FreeBSD 5.<var
class="REPLACEABLE">X</var> versus running FreeBSD 4.<var
class="REPLACEABLE">X</var>.</p>

<div class="IMPORTANT">
<blockquote class="IMPORTANT">
<p><b>Important:</b> Upgrading FreeBSD should, of course, only be attempted after backing
up <span class="emphasis"><i class="EMPHASIS">all</i></span> data and configuration
files.</p>
</blockquote>
</div>
</div>
</div>

<hr />
<p align="center"><small>This file, and other release-related documents, can be
downloaded from <a href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

<p align="center"><small>For questions about FreeBSD, read the <a
href="http://www.FreeBSD.org/docs.html">documentation</a> before contacting &#60;<a
href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

<p align="center"><small>For questions about this documentation, e-mail &#60;<a
href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</small></p>

<br />
<br />
++++


